package ConjuntoDifuso;

import java.util.ArrayList;
import java.util.Iterator;

public class Alternativa {

    private ArrayList<ConjuntoIntuicionista> criterios;

    /**
     * Constructor vacio.
     */
    public Alternativa() {
        criterios = new ArrayList<ConjuntoIntuicionista>();
    }

    /**
     * Constructor para crear una alternativa con diferentes criterios.
     *
     * @param criterios ArrayList con los criterios de cada uno de los expertos.
     */
    public Alternativa(ArrayList<ConjuntoIntuicionista> criterios) {
        this.criterios = criterios;
    }

    public int getCantidadCriterios() {
        return criterios.size();
    }

    public Iterator<ConjuntoIntuicionista> getIterator() {
        return criterios.iterator();
    }

    public ConjuntoIntuicionista elementAt(int i) {
        if (i < criterios.size() && i >= 0) {
            return criterios.get(i);
        } else {
            throw new IndexOutOfBoundsException("Intentando acceder a un indice ilegal. Size="
                    + criterios.size() + " i=" + i);
        }
    }

    public void addCriterio(ConjuntoIntuicionista c) {
        criterios.add(c);
    }
}
