package ConjuntoDifuso;

public class ConjuntoIntuicionista {

    private double pertenencia;
    private double noPertenencia;

    /**
     * Constructor vacio.
     *
     */
    public ConjuntoIntuicionista() {
        this.pertenencia = 0.0;
        this.noPertenencia = 0.0;
    }

    /**
     * Constructor del conjunto intuicionista de Atanassov.
     *
     * @param pertenencia La pertenencia al conjunto intuicionista de Atanassov.
     * @param noPertenencia La no pertenencia al conjunto intuicionista de Atanassov.
     */
    public ConjuntoIntuicionista(double pertenencia, double noPertenencia) {
        if (pertenencia >= 0 && pertenencia <= 1 && noPertenencia >= 0 && noPertenencia <= 1
                && pertenencia + noPertenencia >= 0 && pertenencia + noPertenencia <= 1) {
            this.pertenencia = pertenencia;
            this.noPertenencia = noPertenencia;
        } else {
            throw new ArithmeticException("Valores de pertenencia y no pertenencia invalidos: u="
                    + pertenencia + " v=" + noPertenencia);
        }
    }

    public double getNoPertenencia() {
        return noPertenencia;
    }

    public void setNoPertenencia(double noPertenencia) {
        if (noPertenencia >= 0 && noPertenencia <= 1 && pertenencia + noPertenencia >= 0 && pertenencia + noPertenencia <= 1) {
            this.noPertenencia = noPertenencia;
        } else {
            throw new ArithmeticException("Valor de no pertenencia invalido: " + noPertenencia);
        }
    }

    public double getPertenencia() {
        return pertenencia;
    }

    public void setPertenencia(double pertenencia) {
        if (pertenencia >= 0 && pertenencia <= 1 && pertenencia + noPertenencia >= 0 && pertenencia + noPertenencia <= 1) {
            this.pertenencia = pertenencia;
        } else {
            throw new ArithmeticException("Valor de pertenencia invalido: " + pertenencia);
        }
    }

    public void negar() {

        double aux = pertenencia;
        pertenencia = noPertenencia;
        noPertenencia = aux;
    }

    public double entropia() {
        return 1 - pertenencia - noPertenencia;
    }

    public double biEntropia() {
        double e = 1/8;
        return Math.min(Math.min(2*(1-pertenencia),2*(1-noPertenencia)),Math.min(Math.max(2*pertenencia,e),Math.max(2*noPertenencia,e)));
    }
}
