package ConjuntoDifuso;

/**
 *
 * @author http://stackoverflow.com/questions/951848/java-array-sort-quick-way-to-get-a-sorted-list-of-indices-of-an-array
 */
public class QuickSort {

    public QuickSort() {
    }

    /**
     * Algoritmo QuickSort para ordenar de forma ascendiente los indices de un array
     * en funcion de los valores en dichos indices.
     *
     * @param main Array a ordenar en funcion de los indices
     * @param index Array con los indices del main. Tiene la siguiente forma: [1,2,3..]
     */
    public static void quicksort(double[] main, int[] index) {
        quicksort(main, index, 0, index.length - 1);
    }

    // quicksort a[left] to a[right]
    public static void quicksort(double[] a, int[] index, int left, int right) {
        if (right <= left) {
            return;
        }
        int i = partition(a, index, left, right);
        quicksort(a, index, left, i - 1);
        quicksort(a, index, i + 1, right);
    }

    // partition a[left] to a[right], assumes left < right
    private static int partition(double[] a, int[] index, int left, int right) {
        int i = left - 1;
        int j = right;
        while (true) {
            while (less(a[++i], a[right])) // find item on left to swap
            // a[right] acts as sentinel
            {
                while (less(a[right], a[--j])) // find item on right to swap
                {
                    if (j == left) {
                        break;           // don't go out-of-bounds
                    }
                }
            }
            if (i >= j) {
                break;                  // check if pointers cross
            }
            exch(a, index, i, j);               // swap two elements into place
        }
        exch(a, index, i, right);               // swap with partition element
        return i;
    }

    // is x < y ?
    private static boolean less(double x, double y) {
        return (x > y);
//        return (x < y);
    }

    // exchange a[i] and a[j]
    private static void exch(double[] a, int[] index, int i, int j) {
        double swap = a[i];
        a[i] = a[j];
        a[j] = swap;
        int b = index[i];
        index[i] = index[j];
        index[j] = b;
    }
}
