/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package Metodos;

import ConjuntoDifuso.Alternativa;
import ConjuntoDifuso.ConjuntoIntuicionista;
import ConjuntoDifuso.Opciones;

/**
 *
 * @author Timbo
 */
public class BiEntropia1 {

    private final int CRITERIOS = 4;            //FASTEST 2     DEFAULT 4
    private final int ALTERNATIVAS = 2;         //FASTEST 2     DEFAULT 4
    private final double CRECIMIENTO = 0.10;    //FASTEST 0.10  DEFAULT 0.05
    private final int PRECISION = 2;            //DEFAULT 2
    private final double U = 0.5;               //FASTEST 0.6   DEFAULT 0.5
    private final double V = 0.5;               //FASTEST 0.4   DEFAULT 0.5
    private final double MAX = 0.9;
    private final double MIN = 0.1;

    private double[][] elementos = new double[ALTERNATIVAS][CRITERIOS * 2];
    private Opciones datosE;
    private Opciones datosBE;
    private boolean parar = false;
    private int iguales = 0;

    public BiEntropia1() {

        for (int i = 0; i < elementos.length; i++) {
            init(elementos[i]);
        }

        long iter = 0;
        while (!parar) {
            
            if (iter >= 99999999) {
                System.out.println("CHECK:");
                mostrarIFS();
                System.out.println();
                iter = 0;
            }
//            mostrarIFS();
//            System.out.println();
            if (isValid()) {
                datosE = createOpciones();
                datosBE = createOpciones();
                calcularIguales();
            }

            next(0);
            iter++;
        }
    }

    /**
     * Este metodo verifica si los conjuntos creados son legales, es decir que la suma
     * entre la mu y la nu es menor o igual a 1.
     *
     * @return true si la suma de mu y nu es menor o igual 1, false en cualquier otro caso.
     */
    private boolean isValid() {

        for (int i = 0; i < elementos.length; i++) {
            for (int j = 0; j < elementos[0].length; j += 2) {
                if (elementos[i][j] + elementos[i][j + 1] > 1.0) {         //TODO si no hay resultados prueba quitar el =
                    return false;
                }
            }
        }
        return true;
    }

    private void init(double[] arr) {
        for (int i = 0; i < arr.length; i++) {
            if (i % 2 == 0) {
                arr[i] = U;
            } else {
                arr[i] = V;
            }
        }
    }

    private Opciones createOpciones() {
        Opciones datos = new Opciones();
        Alternativa a;

        for (int i = 0; i < elementos.length; i++) {
            a = new Alternativa();
            for (int j = 0; j < elementos[0].length; j += 2) {
                a.addCriterio(new ConjuntoIntuicionista(elementos[i][j], elementos[i][j + 1]));
            }
            datos.addAlternativa(a);
        }
        return datos;
    }

    private void next(int alt) {

        elementos[alt][0] += CRECIMIENTO;
        for (int i = 0; i < elementos[alt].length; i++) {
            if (hasCheckedArray(elementos[alt]) && alt == ALTERNATIVAS - 1) {
                parar = true;
                break;
            } else if (hasCheckedArray(elementos[alt]) && alt < ALTERNATIVAS - 1) {
                next(alt + 1);
                init(elementos[alt]);
                break;
            }

            if (i % 2 == 0 && elementos[alt][i] > MAX) {
                elementos[alt][i] = U;
                elementos[alt][i + 1] -= CRECIMIENTO;
            } else if (i % 2 != 0 && elementos[alt][i] < MIN) {
                elementos[alt][i] = V;
                elementos[alt][i + 1] += CRECIMIENTO;
            } else {
                break;
            }
        }
    }

    //TODO acuerdate que hace una iteracion de menos :(
    //TODO deberia redondear pero va mucho mas lento :O
    private boolean hasCheckedArray(double[] arr) {
        for (int i = 0; i < arr.length; i++) {
            if (i % 2 == 0 && arr[i] + CRECIMIENTO > MAX) {
                continue;
            } else if (i % 2 == 1 && arr[i] - CRECIMIENTO < MIN) {
                continue;
            } else {
                return false;
            }
        }
        return true;
    }

    private void calcularIguales() {

//        mostrarIFS();
        datosE.calcularPesos();
        datosE.calcularCoeficienteCorrelacion();

        if (datosE.isEqual(2) && !areRepeated()) {

            datosBE.calcularPesosBE();
            datosBE.calcularCoeficienteCorrelacion();
            if (!datosBE.isEqualDeVerda(2, PRECISION)) {
                System.out.println("Con entropia:");
                datosE.mostrarCoeficientes();
                System.out.println("Con bi-entropia:");
                datosBE.mostrarCoeficientes();
                System.out.println();
                mostrarIFS();
                System.out.println("////////////////////////////////");
                iguales++;
            }
        }
    }

    private boolean areRepeated() {

        for (int i = 0; i < elementos.length - 1; i++) {
            for (int j = i + 1; j < elementos.length; j++) {
                if (areTheSame(elementos[i], elementos[j])) {
                    return true;
                }
            }
        }
        return false;
    }

    private boolean areTheSame(double[] arr1, double[] arr2) {
        for (int i = 0; i < arr1.length; i++) {
            if (arr1[i] != arr2[i]) {
                return false;
            }
        }
        return true;
    }

    private void mostrarIFS() {

        for (int i = 0; i < elementos.length; i++) {
            System.out.print("A" + (i + 1) + "=");
            for (int j = 0; j < elementos[0].length; j++) {
                System.out.printf(" %.2f", elementos[i][j]);
            }
            System.out.println();
        }
    }

    private double round(double d) {
        
        return d = (int) (d * 100 + 0.5) / 100.0;
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {

        BiEntropia1 be = new BiEntropia1();
        System.out.println("Numero de casos iguales encontrados: " + be.iguales);
        System.out.println("Bueno, en realidad los casos distintos son " + be.iguales / 2
                + " dado que no diferencia si se le dan los valores de A a B y viceversa. =(");

        System.out.println("VERSION 1.1");
    }
}
