package Metodos;

import ConjuntoDifuso.Alternativa;
import ConjuntoDifuso.ConjuntoIntuicionista;
import ConjuntoDifuso.Opciones;
import java.util.Arrays;

public class BiEntropiaThread extends Thread {

    private final int CRITERIOS = 4;                   //FASTEST 2     DEFAULT 4
    private final int ALTERNATIVAS = 4;                //FASTEST 2     DEFAULT 4
    public final static double CRECIMIENTO = 0.05;     //FASTEST 0.10  DEFAULT 0.05
    private final int PRECISION = 2;                   //DEFAULT 2
    public final static double U = 0.5;                //FASTEST 0.6   DEFAULT 0.5
    public final static double V = 0.4;                //FASTEST 0.4   DEFAULT 0.5
    public final static double MAX = 0.8;              //FASTEST 0.8   DEFAULT 0.9
    public final static double MIN = 0.1;
    private double[][] elementos = new double[ALTERNATIVAS][CRITERIOS * 2];
    private Opciones datosE;
    private Opciones datosBE;
    private boolean parar = false;
    private int iguales = 0;
    private double initial;
    private double limite;

    public BiEntropiaThread(double i, double l) {

        this.initial = i;
        this.limite = l;
    }

    @Override
    public void run() {

        for (int i = 0; i < elementos.length - 2; i++) {
            init(elementos[i]);
        }


        /*
        A1= 0.7 0.25 0.75 0.15 0.75 0.15 0.65 0.2
        A2= 0.75 0.15 0.65 0.25 0.75 0.15 0.7 0.2
        A3= 0.6 0.15 0.65 0.15 0.5 0.2 0.6 0.25
        A4= 0.65 0.25 0.7 0.2 0.75 0.15 0.55 0.35

        1:
        A1= 0.75 0.2 0.75 0.1 0.75 0.15 0.55 0.3
        A2= 0.65 0.25 0.7 0.25 0.75 0.15 0.7 0.2
        A3= 0.6 0.15 0.65 0.15 0.5 0.2 0.6 0.25
        A4= 0.65 0.25 0.7 0.2 0.75 0.15 0.55 0.35

        2:
        A1= 0.7 0.2 0.55 0.25 0.7 0.15 0.6 0.1
        A2= 0.7 0.15 0.55 0.1 0.7 0.2 0.6 0.25
        A3= 0.55 0.35 0.65 0.15 0.7 0.15 0.6 0.15
        A4= 0.5 0.4 0.7 0.1 0.65 0.15 0.65 0.15
         */


        /*
        elementos[ALTERNATIVAS - 3] = new double[] {0.7, 0.15, 0.65, 0.25, 0.75, 0.15, 0.7, 0.2};
        elementos[ALTERNATIVAS - 2] = new double[] {0.6, 0.15, 0.65, 0.15, 0.5, 0.2, 0.6, 0.25};
        elementos[ALTERNATIVAS - 1] = new double[] {0.65, 0.25, 0.7, 0.2, 0.75, 0.15, 0.55, 0.35};
        */

        elementos[ALTERNATIVAS - 3] = new double[] {0.6, 0.2, 0.55, 0.1, 0.7, 0.2, 0.6, 0.25};
        elementos[ALTERNATIVAS - 2] = new double[] {0.55, 0.35, 0.65, 0.15, 0.7, 0.15, 0.6, 0.15};
        elementos[ALTERNATIVAS - 1] = new double[] {0.5, 0.4, 0.7, 0.1, 0.65, 0.15, 0.65, 0.15};



//        elementos[ALTERNATIVAS - 1][CRITERIOS * 2 - 1] = initial;

        long iter = 0;
        StringBuilder txt = new StringBuilder("CHECK:\n");
        while (!parar) {

            if (iter >= 99999999) {
                txt.delete(7, txt.length());
                System.out.println(txt.append(mostrarIFS()));
                iter = 0;
            }
            iter++;

            if (isValid()) {
                datosE = createOpciones();
                datosBE = createOpciones();
                calcularIguales();
                iter = 0;
            }

            next(0);

        }

        System.out.println("Numero de casos iguales encontrados: " + iguales);
//        System.out.println("Bueno, en realidad los casos distintos son " + iguales / 2
//                + " dado que no diferencia si se le dan los valores de A a B y viceversa. =(");
    }

    /**
     * Este metodo verifica si los conjuntos creados son legales, es decir que la suma
     * entre la mu y la nu es menor o igual a 1.
     *
     * @return true si la suma de mu y nu es menor o igual 1, false en cualquier otro caso.
     */
    private boolean isValid() {

        for (int i = 0; i < elementos.length; i++) {
            for (int j = 0; j < elementos[0].length; j += 2) {
                if (elementos[i][j] + elementos[i][j + 1] > 1.0) {         //TODO si no hay resultados prueba quitar el =
                    return false;
                }
            }
        }
        return true;
    }

    private void init(double[] arr) {
        Arrays.fill(arr, U);
        for (int i = 1; i <= arr.length - 1; i += 2) {
            arr[i] = V;
        }
    }

    private Opciones createOpciones() {
        Opciones datos = new Opciones();
        Alternativa a;

        for (int i = 0; i < elementos.length; i++) {
            a = new Alternativa();
            for (int j = 0; j < elementos[0].length; j += 2) {
                a.addCriterio(new ConjuntoIntuicionista(elementos[i][j], elementos[i][j + 1]));
            }
            datos.addAlternativa(a);
        }
        return datos;
    }

    //TODO implementa un bucle que valla HACIA ATRAS verificando si los IFS suman 1
    private void next(int alt) {

        elementos[alt][0] += CRECIMIENTO;
        for (int i = 0; i < elementos[alt].length; i++) {

            if (i % 2 == 0 && elementos[alt][i] > MAX) {
                elementos[alt][i] = U;
                elementos[alt][i + 1] -= CRECIMIENTO;
            } else if (i % 2 != 0 && elementos[alt][i] < MIN) {
                elementos[alt][i] = V;
                if (i + 1 < CRITERIOS * 2) {
                    elementos[alt][i + 1] += CRECIMIENTO;
                }
            } else {
                break;
            }
        }

        quitarImposibles();
        if (hasCheckedAll()) {
            parar = true;
        }

        if (hasCheckedArray(elementos[alt]) && alt < ALTERNATIVAS - 1) {
            next(alt + 1);
            init(elementos[alt]);               //TODO si no hay resultados prueba quitar el =
//        } else if (elementos[ALTERNATIVAS - 1][CRITERIOS * 2 - 1] + elementos[ALTERNATIVAS - 1][CRITERIOS * 2 - 2] > 1.0) {
//            parar = true;
//        } else if (round(elementos[ALTERNATIVAS - 1][CRITERIOS * 2 - 1]) == limite) {
//            parar = true;
        }
    }

    //TODO deberia redondear pero va mucho mas lento :O
    private boolean hasCheckedArray(double[] arr) {
        for (int i = 0; i < arr.length; i++) {
            if (i % 2 == 0 && arr[i] + CRECIMIENTO > MAX) {
                continue;
            } else if (i % 2 == 1 && arr[i] - CRECIMIENTO < MIN) {
                continue;
            } else {
                return false;
            }
        }
        return true;
    }

    private boolean hasCheckedAll() {
        for (int i = 0; i < elementos.length; i++) {
            if (!hasCheckedArray(elementos[i])) {
                return false;
            }
        }
        return true;
    }

    private void quitarImposibles() {

        outer:
        for (int i = elementos.length - 1; i >= 0; i--) {
            for (int j = elementos[0].length - 1; j >= 0; j -= 2) {  //TODO si no hay resultados prueba quitar el =
                if (elementos[i][j] + elementos[i][j - 1] > 1.0) {
                    reiniciarHasta(i, j);
                    elementos[i][j] -= CRECIMIENTO;
                }
            }
        }
    }

    private void reiniciarHasta(int index1, int index2) {
        for (int i = 0; i < index1; i++) {
            init(elementos[i]);
        }
        for (int i = 0; i < index2; i++) {
            if (i % 2 == 0) {
                elementos[index1][i] = U;
            } else {
                elementos[index1][i] = V;
            }
        }
    }

    private void calcularIguales() {

        datosE.calcularPesos();
        datosE.calcularCoeficienteCorrelacion();

        if (datosE.isEqual(2) && !areRepeated()) {

            datosBE.calcularPesosBE();
            datosBE.calcularCoeficienteCorrelacion();
            if (!datosBE.isEqualDeVerda(2, PRECISION)) {
                System.out.println("Con entropia:");
                datosE.mostrarCoeficientes();
                System.out.println("Con bi-entropia:");
                datosBE.mostrarCoeficientes();
                System.out.println();
                System.out.println(mostrarIFS());
                System.out.println("////////////////////////////////");
                iguales++;
            }
        }
    }

    private boolean areRepeated() {

        for (int i = 0; i < elementos.length - 1; i++) {
            for (int j = i + 1; j < elementos.length; j++) {
                if (areTheSame(elementos[i], elementos[j])) {
                    return true;
                }
            }
        }
        return false;
    }

    private boolean areTheSame(double[] arr1, double[] arr2) {
        for (int i = 0; i < arr1.length; i++) {
            if (arr1[i] != arr2[i]) {
                return false;
            }
        }
        return true;
    }

    private StringBuilder mostrarIFS() {

        StringBuilder txt = new StringBuilder("");
        for (int i = 0; i < elementos.length; i++) {
            txt.append("A").append(i + 1).append("=");
//            System.out.print("A" + (i + 1) + "=");
            for (int j = 0; j < elementos[0].length; j++) {
                txt.append(" ").append(round(elementos[i][j]));
//                System.out.printf(" %.2f", elementos[i][j]);
            }
            txt.append("\n");
//            System.out.println();
        }
        return txt;
    }

    private double round(double d) {

        return d = (int) (d * 100 + 0.5) / 100.0;
    }
}
